View Issue Details

IDProjectCategoryView StatusLast Update
0024735LazarusLCLpublic2015-05-15 10:01
ReporterVojtech Cihak Assigned ToZeljan Rikalo  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Platformamd64OSLinux 
Product Version1.1 (SVN) 
Summary0024735: TCustomControl, csNoFocus and TabStop
DescriptionTCustomControl is created with TabStop=True and with flag csNoFocus in ControlStyle. I know it is unusual.
IMO:
When there is TabStop=True and with flag csNoFocus set, one of them should have precedence.
Behaviour should be the same for GTK and Qt.
Focus should be never lost.

I don't know what Delphi do it this special case.
Steps To ReproduceRun demo. Focus is on the Edit. The red rectangle cannot obtain focus on mouse click - correct.
But when you press "TAB", then
on Qt: focus is lost
on GTK: focus is on the red rectangle although it has csNoFocus in ControlStyle
Additional InformationLazarus 1.1 r42054M FPC 2.7.1 x86_64-linux-qt
TagsNo tags attached.
Fixed in Revision44921
LazTarget-
WidgetsetGTK 2, QT
Attached Files

Relationships

related to 0028090 closedZeljan Rikalo [Qt] SpeedBtn of TEditButton steals focus 

Activities

Vojtech Cihak

2013-07-12 14:12

reporter  

Zeljan Rikalo

2013-07-12 17:41

developer   ~0068816

IMO if csNoFocus is set than that control should not take focus in any case (mouse or kbd). Must look into Delphi docs to see what's exact meaning of csNoFocus.

Paul Ishenin

2013-07-19 02:21

manager   ~0068941

csNoFocus is a LCL invention which is implemented only on carbon, cocoa and qt.

Zeljan Rikalo

2014-05-05 07:48

developer   ~0074772

Please test and close if ok.

Vojtech Cihak

2014-05-05 08:26

reporter   ~0074773

I tested in r.44921, Qt and GTK2. Thanks.

Issue History

Date Modified Username Field Change
2013-07-12 14:12 Vojtech Cihak New Issue
2013-07-12 14:12 Vojtech Cihak File Added: CustomControlLostFocus.zip
2013-07-12 17:41 Zeljan Rikalo Note Added: 0068816
2013-07-19 02:21 Paul Ishenin Note Added: 0068941
2014-05-04 20:35 Zeljan Rikalo Assigned To => Zeljan Rikalo
2014-05-04 20:35 Zeljan Rikalo Status new => assigned
2014-05-05 07:48 Zeljan Rikalo Fixed in Revision => 44921
2014-05-05 07:48 Zeljan Rikalo LazTarget => -
2014-05-05 07:48 Zeljan Rikalo Note Added: 0074772
2014-05-05 07:48 Zeljan Rikalo Status assigned => resolved
2014-05-05 07:48 Zeljan Rikalo Resolution open => fixed
2014-05-05 08:26 Vojtech Cihak Note Added: 0074773
2014-05-05 08:26 Vojtech Cihak Status resolved => closed
2015-05-15 10:01 Zeljan Rikalo Relationship added related to 0028090